Scala Compiler2.13.5 < Back


# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package backend
  Definition Classes
    nsc
-  package jvm
  Definition Classes
    backend
-  package opt
  Definition Classes
    jvm
- BoxUnbox
- ByteCodeRepository
- BytecodeUtils
- CallGraph
- ClosureOptimizer
- CopyProp
- InlineInfoAttribute
- InlineInfoAttributePrototype
- Inliner
- InlinerHeuristics
- LabelNotLive
- LocalOpt
- LocalOptImpls
- LruMap
- RemovePair
- RemovePairDependency

c

scala.tools.nsc.backend.jvm.opt

# InlinerHeuristics

###
Companion object InlinerHeuristics

#### abstract class InlinerHeuristics extends PerRunInit

Source
  InlinerHeuristics.scala

Linear Supertypes
PerRunInit, AnyRef, Any
Type Hierarchy

Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. InlinerHeuristics
2. PerRunInit
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. Protected

### Instance Constructors

1.  new InlinerHeuristics()

### Type Members

1.  final case class InlineRequest(callsite: (callGraph)#Callsite, reason: InlineReason) extends Product with Serializable

### Abstract Value Members

1.  abstract val postProcessor: PostProcessor

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##: Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from InlinerHeuristics toany2stringadd[InlinerHeuristics] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (InlinerHeuristics, B)
   Implicit
     This member is added by an implicit conversion from InlinerHeuristics toArrowAssoc[InlinerHeuristics] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def canInlineFromSource(sourceFilePath: Option[String], calleeDeclarationClass: InternalName): Boolean
8.  def clone(): AnyRef
   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws(classOf[java.lang.CloneNotSupportedException]) @native()
9.  def ensuring(cond: (InlinerHeuristics) => Boolean, msg: => Any): InlinerHeuristics
   Implicit
     This member is added by an implicit conversion from InlinerHeuristics toEnsuring[InlinerHeuristics] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: (InlinerHeuristics) => Boolean): InlinerHeuristics
    Implicit
      This member is added by an implicit conversion from InlinerHeuristics toEnsuring[InlinerHeuristics] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean, msg: => Any): InlinerHeuristics
    Implicit
      This member is added by an implicit conversion from InlinerHeuristics toEnsuring[InlinerHeuristics] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean): InlinerHeuristics
    Implicit
      This member is added by an implicit conversion from InlinerHeuristics toEnsuring[InlinerHeuristics] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
14.  def equals(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef → Any
15.  def finalize(): Unit
    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.Throwable])
16.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from InlinerHeuristics toStringFormat[InlinerHeuristics] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
17.  final def getClass(): Class[_ <: AnyRef]
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
18.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
    Annotations
      @native()
19.  def initialize(): Unit
    Definition Classes
      PerRunInit
20.  def inlineRequest(callsite: (callGraph)#Callsite): Option[Either[OptimizerWarning, InlineRequest]]

    Returns the inline request for a callsite if the callsite should be inlined according to the current heuristics (`-Yopt-inline-heuristics`).

    Returns the inline request for a callsite if the callsite should be inlined according to the current heuristics (`-Yopt-inline-heuristics`).

    returns

      `None` if this callsite should not be inlined according to the active heuristic `Some(Left)` if the callsite should be inlined according to the heuristic, but cannot be inlined according to an early, incomplete check (see earlyCanInlineCheck) `Some(Right)` if the callsite should be inlined (it's still possible that the callsite cannot be inlined in the end, for example if it contains instructions that would cause an IllegalAccessError in the new class; this is checked in the inliner)

21.  lazy val inlineSourceMatcher: LazyVar[InlineSourceMatcher]
22.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
23.  def javaSam(internalName: InternalName): Option[String]
24.  val maxSize: Int
25.  val mediumSize: Int
26.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
27.  final def notify(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
28.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
    Annotations
      @native()
29.  def perRunInit(init: => Unit): Unit
    Definition Classes
      PerRunInit
30.  def selectCallsitesForInlining: Map[MethodNode, Set[InlineRequest]]

    Select callsites from the call graph that should be inlined, grouped by the containing method.

    Select callsites from the call graph that should be inlined, grouped by the containing method. Cyclic inlining requests are allowed, the inliner will eliminate requests to break cycles.

31.  def selectRequestsForMethodSize(method: MethodNode, requests: List[InlineRequest], methodSizes: Map[MethodNode, Int]): List[InlineRequest]
32.  val smallSize: Int
33.  final def synchronized[T0](arg0: => T0): T0
    Definition Classes
      AnyRef
34.  def toString(): String
    Definition Classes
      AnyRef → Any
35.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
36.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException])
37.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws(classOf[java.lang.InterruptedException]) @native()

### Deprecated Value Members

1.  def →[B](y: B): (InlinerHeuristics, B)
   Implicit
     This member is added by an implicit conversion from InlinerHeuristics toArrowAssoc[InlinerHeuristics] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @deprecated
   Deprecated

     (Since version 2.13.0) Use `->` instead. If you still wish to display it as one character, consider using a font with programming ligatures such as Fira Code.

### Inherited from PerRunInit

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd fromInlinerHeuristics to any2stringadd[InlinerHeuristics]

### Inherited by implicit conversion StringFormat fromInlinerHeuristics to StringFormat[InlinerHeuristics]

### Inherited by implicit conversion Ensuring fromInlinerHeuristics to Ensuring[InlinerHeuristics]

### Inherited by implicit conversion ArrowAssoc fromInlinerHeuristics to ArrowAssoc[InlinerHeuristics]

### Ungrouped